﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.31
@EndOfDesignText@
'Custom BANano View class

'Uncomment the events you want to show to the user and implement the HandleEvents in DesignerCreateView 
'#Event: Focus (event As BANanoEvent)
'#Event: Blur (event As BANanoEvent)
'#Event: Resize (event As BANanoEvent)
'#Event: Scroll (event As BANanoEvent)
'#Event: Keydown (event As BANanoEvent)
'#Event: KeyPress (event As BANanoEvent)
'#Event: KeyUp (event As BANanoEvent)
'#Event: Click (event As BANanoEvent)
'#Event: ContextMenu (event As BANanoEvent)
'#Event: Dblclick (event As BANanoEvent)
'#Event: MouseDown (event As BANanoEvent)
'#Event: MouseEnter (event As BANanoEvent)
'#Event: MouseLeave (event As BANanoEvent)
'#Event: MouseMove (event As BANanoEvent)
'#Event: MouseOver (event As BANanoEvent)
'#Event: MouseOut (event As BANanoEvent)
'#Event: MouseUp (event As BANanoEvent)
'#Event: Wheel (event As BANanoEvent)
'#Event: Drag (event As BANanoEvent)
'#Event: DragEnd (event As BANanoEvent)
'#Event: DragEnter (event As BANanoEvent)
'#Event: DragStart (event As BANanoEvent)
'#Event: DragLeave (event As BANanoEvent)
'#Event: DragOver (event As BANanoEvent)
'#Event: Drop (event As BANanoEvent)
'#Event: TouchCancel (event As BANanoEvent)
'#Event: TouchEnd (event As BANanoEvent)
'#Event: TouchEnter (event As BANanoEvent)
'#Event: TouchLeave (event As BANanoEvent)
'#Event: TouchMove (event As BANanoEvent)
'#Event: TouchStart (event As BANanoEvent)
'#Event: Change (event As BANanoEvent)

' Properties that will be show in the ABStract Designer.  They will be passed in the props map in DesignerCreateView (Case Sensitive!)
#DesignerProperty: Key: Classes, DisplayName: Classes, FieldType: String, DefaultValue: , Description: Classes added to the HTML tag.
#DesignerProperty: Key: Style, DisplayName: Style, FieldType: String, DefaultValue: , Description: Styles added to the HTML tag. Must be a json String.
#DesignerProperty: Key: MarginLeft, DisplayName: Margin Left, FieldType: String, DefaultValue: , Description: Margin Left
#DesignerProperty: Key: MarginRight, DisplayName: Margin Right, FieldType: String, DefaultValue: , Description: Margin Right
#DesignerProperty: Key: MarginTop, DisplayName: Margin Top, FieldType: String, DefaultValue: , Description: Margin Top
#DesignerProperty: Key: MarginBottom, DisplayName: Margin Bottom, FieldType: String, DefaultValue: , Description: Margin Bottom
#DesignerProperty: Key: PaddingLeft, DisplayName: Padding Left, FieldType: String, DefaultValue: , Description: Padding Left
#DesignerProperty: Key: PaddingRight, DisplayName: Padding Right, FieldType: String, DefaultValue: , Description: Padding Right
#DesignerProperty: Key: PaddingTop, DisplayName: Padding Top, FieldType: String, DefaultValue: , Description: Padding Top
#DesignerProperty: Key: PaddingBottom, DisplayName: Padding Bottom, FieldType: String, DefaultValue: , Description: Padding Bottom
#DesignerProperty: Key: Height, DisplayName: Height, FieldType: String, DefaultValue: 400px, Description: Height
#DesignerProperty: Key: Width, DisplayName: Width, FieldType: String, DefaultValue: 100%, Description: Width
#DesignerProperty: Key: ChartType, DisplayName: Chart Type, FieldType: String, DefaultValue: LineChart, Description: Chart Type, List: LineChart|PieChart|ColumnChart|BarChart|AreaChart|ScatterChart|BubbleChart
#DesignerProperty: Key: MaxValue, DisplayName: MaxValue, FieldType: String, DefaultValue: , Description: Max Value
#DesignerProperty: Key: Stacked, DisplayName: Stacked, FieldType: Boolean, DefaultValue: False, Description: Stacked
#DesignerProperty: Key: XTitle, DisplayName: XTitle, FieldType: String, DefaultValue: , Description: XTitle
#DesignerProperty: Key: YTitle, DisplayName: YTitle, FieldType: String, DefaultValue: , Description: YTitle
#DesignerProperty: Key: Download, DisplayName: Download, FieldType: Boolean, DefaultValue: True, Description: Download
#DesignerProperty: Key: Donut, DisplayName: Donut, FieldType: Boolean, DefaultValue: False, Description: Donut
#DesignerProperty: Key: Percentage, DisplayName: Percentage, FieldType: Boolean, DefaultValue: False, Description: Percentage
#DesignerProperty: Key: ShowLine, DisplayName: ShowLine, FieldType: Boolean, DefaultValue: False, Description: ShowLine
#DesignerProperty: Key: MinValue, DisplayName: MinValue, FieldType: String, DefaultValue: , Description: Min Value
#DesignerProperty: Key: Title, DisplayName: Title, FieldType: String, DefaultValue: , Description: Title
#DesignerProperty: Key: Prefix, DisplayName: Prefix, FieldType: String, DefaultValue: , Description: Prefix
#DesignerProperty: Key: Suffix, DisplayName: Suffix, FieldType: String, DefaultValue: , Description: Suffix
#DesignerProperty: Key: Curve, DisplayName: Curve, FieldType: Boolean, DefaultValue: False, Description: Curve
#DesignerProperty: Key: Discrete, DisplayName: Discrete, FieldType: Boolean, DefaultValue: False, Description: Discrete
#DesignerProperty: Key: XNumeric, DisplayName: XNumeric, FieldType: Boolean, DefaultValue: False, Description: XNumeric
#DesignerProperty: Key: LegendPosition, DisplayName: Legend Position, FieldType: String, DefaultValue: top , Description: Legend Position, List: top|bottom|right

	
Sub Class_Globals
    Private BANano As BANano 'ignore
	Private mName As String 'ignore
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mTarget As BANanoElement 'ignore
	Private mElement As BANanoElement 'ignore
	
	Private mClasses As String = ""
	Private mStyle As String = ""
	Public MarginLeft As String = ""
	Public MarginRight As String = ""
	Public MarginTop As String = ""
	Public MarginBottom As String = ""
	Public PaddingLeft As String = ""
	Public PaddingRight As String = ""
	Public PaddingTop As String = ""
	Public PaddingBottom As String = ""
	Public Height As String = "400px"
	Public Width As String = "100%"
	
	Public XNumeric As Boolean = False
	Private colorMap As Map
	Private series As Map
	Private data As Map
	Public MaxValue As String = ""
	Public Stacked As Boolean = False
	Public XTitle As String = ""
	Public YTitle As String = ""
	Public Download As Boolean = True
	Public Donut As Boolean = False
	Private seriestitle As Map
	Public Percentage As Boolean = False
	Public BackgroundColor As String = ""
	Public zoomType As String = ""
	Public ShowLine As Boolean = False
	Public BorderWidth As Int
	Public BorderDash As Int
	Public MinValue As String = ""
	Public LineLabel As String
	Private colors As List
	Public Discrete As Boolean
	Public Curve As Boolean = False
	Public Title As String = ""
	Public Points As Boolean = False
	Public Prefix As String = ""
	Public Suffix As String = ""
	Public Thousands As String = ","
	Public Decimal As String = "."
	Private coptions As Map
	Private xtype As String = ""
	Public ChartType As String = "LineChart"
	Public LegendPosition As String = "top"
	'series colors
	Public color_red As String = "red"
	Public color_pink As String = "pink"
	Public color_purple As String = "purple"
	Public color_indigo As String = "indigo"
	Public color_blue As String = "blue"
	Public color_lightblue As String = "lightblue"
	Public color_cyan As String = "cyan"
	Public color_teal As String = "teal"
	Public color_green As String = "green"
	Public color_lime As String = "lime"
	Public color_yellow As String = "yellow"
	Public color_amber As String = "amber"
	Public color_orange As String = "orange"
	Public color_deeporange As String = "deeporange"
	Public color_brown As String = "brown"
	Public color_grey As String = "grey"
	Public color_bluegrey As String = "bluegrey"
	Public color_black As String = "black"
	Public color_white As String = "white"
	Public color_transparent As String = "transparent"
	Public color_dark As String = "dark"
	Public color_light As String = "light"
	Public color_danger As String = "danger"
	Public color_warning As String = "warning"
	Public color_info As String = "info"
	Public color_success As String = "success"
	Public color_secondary As String = "secondary"
	Public color_primary As String = "primary"
	Public color_gray As String = "gray"
	Public color_darkgray As String = "darkgray"
	'chart type
	Public CT_LineChart As String = "LineChart"
	Public CT_PieChart As String = "PieChart"
	Public CT_ColumnChart As String = "ColumnChart"
	Public CT_BarChart As String = "BarChart"
	Public CT_AreaChart As String = "AreaChart"
	Public CT_ScatterChart As String = "ScatterChart"
	Public CT_BubbleChart As String = "BubbleChart"
	'legend position
	Public LP_bottom As String = "bottom"
	Public LP_top As String = "top"
	Public LP_right As String = "right"
End Sub

Public Sub Initialize (CallBack As Object, Name As String, EventName As String)
	mName = Name
	mEventName = EventName.ToLowerCase
	mCallBack = CallBack
	Clear
	InitColorMap
End Sub

' this is the place where you create the view in html and run initialize javascript
Public Sub DesignerCreateView (Target As BANanoElement, Props As Map)
	mTarget = Target

	If Props <> Null Then
		mClasses = Props.Get("Classes")
		mStyle = Props.Get("Style")
		MarginLeft = Props.Get("MarginLeft")
		MarginRight = Props.Get("MarginRight")
		MarginTop = Props.Get("MarginTop")
		MarginBottom = Props.Get("MarginBottom")
		PaddingLeft = Props.Get("PaddingLeft")
		PaddingRight = Props.Get("PaddingRight")
		PaddingTop = Props.Get("PaddingTop")
		PaddingBottom = Props.Get("PaddingBottom")
		Height = Props.Get("Height")
		Width = Props.Get("Width")
		
		'
		ChartType = Props.Get("ChartType")
		MaxValue = Props.Get("MaxValue")
		Stacked = Props.Get("Stacked")
		XTitle = Props.Get("XTitle")
		YTitle = Props.Get("YTitle")
		Download = Props.Get("Download")
		Donut = Props.Get("Donut")
		Percentage = Props.Get("Percentage")
		ShowLine = Props.Get("ShowLine")
		MinValue = Props.Get("MinValue")
		Title = Props.Get("Title")
		Prefix = Props.Get("Prefix")
		Suffix = Props.Get("Suffix")
		Curve = Props.Get("Curve")
		Discrete = Props.Get("Discrete")
		LegendPosition = Props.Get("LegendPosition")
		XNumeric = Props.Get("XNumeric")
	End If
	
	Dim exStyle As String = BuildExStyle
	
	mElement = mTarget.Append($"<div id="${mName}" class="${mClasses}" style="${exStyle}${mStyle}"></div>"$).Get("#" & mName)
		
	'' defining events is very simple. Note that it has to be run AFTER adding it to the HTML DOM! eventName must be lowercase!
	'mElement.HandleEvents("click", mCallBack, mEventName & "_click")
	'mElement.HandleEvents("mouseenter", Me, "mouseenter")
End Sub

public Sub AddToParent(targetID As String)
	mTarget = BANano.GetElement("#" & targetID.ToLowerCase)
	DesignerCreateView(mTarget, Null)
	Refresh
End Sub

public Sub Remove()
	mTarget.Empty
	BANano.SetMeToNull
End Sub

public Sub Trigger(event As String, params() As String)
	If mElement <> Null Then
		mElement.Trigger(event, params)
	End If
End Sub

private Sub InitColorMap
	colorMap.Initialize
	colorMap.Put("dark","#343a40")
	colorMap.Put("light","#f8f9fa")
	colorMap.Put("danger","#dc3545")
	colorMap.Put("warning","#ffc107")
	colorMap.Put("info","#17a2b8")
	colorMap.Put("success","#28a745")
	colorMap.Put("secondary","#6c757d")
	colorMap.Put("primary","#007bff")
	colorMap.Put("gray","#6c757d")
	colorMap.Put("darkgray","#343a40")
	colorMap.put("red", "#dc3545")
	colorMap.put("pink", "#e83e8c")
	colorMap.put("purple", "#6f42c1")
	colorMap.put("indigo", "#6610f2")
	colorMap.put("blue", "#007bff")
	colorMap.put("lightblue", "#03a9f4")
	colorMap.put("cyan", "#17a2b8")
	colorMap.put("teal", "#20c997")
	colorMap.put("green", "#28a745")
	colorMap.put("lime", "#cddc39")
	colorMap.put("yellow", "#ffc107")
	colorMap.put("amber", "#fd7e14")
	colorMap.put("orange", "#fd7e14")
	colorMap.put("deeporange", "#ff5722")
	colorMap.put("brown", "#795548")
	colorMap.put("grey", "#9e9e9e")
	colorMap.put("bluegrey", "#607d8b")
	colorMap.put("black", "#000000")
	colorMap.put("white", "#ffffff")
	colorMap.put("transparent", "transparent")
End Sub

public Sub BuildExStyle() As String
	Dim sb As StringBuilder
	sb.Initialize
	If MarginLeft <> "" Then sb.Append("margin-left: " & MarginLeft & ";")
	If MarginRight <> "" Then sb.Append("margin-right: " & MarginRight & ";")
	If MarginTop <> "" Then sb.Append("margin-top: " & MarginTop & ";")
	If MarginBottom <> "" Then sb.Append("margin-bottom: " & MarginBottom & ";")
	If PaddingLeft <> "" Then sb.Append("padding-left: " & PaddingLeft & ";")
	If PaddingRight <> "" Then sb.Append("padding-right: " & PaddingRight & ";")
	If PaddingTop <> "" Then sb.Append("padding-top: " & PaddingTop & ";")
	If PaddingBottom <> "" Then sb.Append("padding-bottom: " & PaddingBottom & ";")
	If Height <> "" Then sb.Append("height: " & Height & ";")
	If Width <> "" Then sb.Append("width: " & Width & ";")
	Return sb.ToString
End Sub

#Region Property Getters and Setters
public Sub setClasses(Classes As String)
	If mElement <> Null Then
		mElement.AddClass(Classes)
	End If
	mClasses = Classes
End Sub

public Sub getClasses() As String
	Return mClasses
End Sub

' must be a json string
' e.g. $"{ "width": "200px", "height": "200px", "background": "green", "border-radius": "5px" }"$
public Sub setStyle(Style As String)
	If mElement <> Null Then
		mElement.SetStyle(Style)
	End If
	mStyle = Style
End Sub

public Sub getStyle() As String
	Return mStyle
End Sub
#End Region

#Region Internal Events

#End Region

'clear the chart contents
Sub Clear As UOEChart
	series.Clear
	data.clear
	seriestitle.clear
	Dim sl As List
	sl.Initialize
	data.Put("a",sl)
	MaxValue = ""
	Stacked = False
	XTitle = ""
	YTitle = ""
	Download = False
	Donut = False
	seriestitle.Initialize
	Percentage = False
	BackgroundColor = ""
	zoomType = ""
	ShowLine = False
	BorderWidth = 0
	BorderDash = 0
	MinValue = ""
	LineLabel = 0
	colors.Initialize
	Discrete = False
	Curve = True
	Title = ""
	Points = True
	Prefix = ""
	Suffix = ""
	Thousands = ","
	Decimal = "."
	coptions.Initialize
	xtype = ""
	XNumeric = False
	Return Me
End Sub

'add a new series, the list will store the data
Sub AddSeries(seriesName As String, seriesCaption As String, seriesColor As String) As UOEChart
	series.Put(seriesName,seriesColor)
	seriestitle.Put(seriesName,seriesCaption)
	Dim sl As List
	sl.Initialize
	data.Put(seriesName,sl)
	Return Me
End Sub

'add xy to a series
Sub AddSeriesXY(seriesName As String, X As String, y As String) As UOEChart
	Dim sE As Boolean = series.ContainsKey(seriesName)
	If sE = False Then
		Log($"UOEChartJS:AddXY:${seriesName} does NOT exist!"$)
		Return Me
	End If
	'get the list of records
	Dim exdata As List = data.Get(seriesName)
	Dim cudata As List
	cudata.Initialize
	cudata.Add(X)
	cudata.Add(y)
	exdata.Add(cudata)
	data.Put(seriesName,exdata)
	Return Me
End Sub

'add xy maps to a series
Sub AddSeriesXYMap(seriesName As String, values As Map) As UOEChart
	For Each strKey As String In values.Keys
		Dim strVal As String = values.Get(strKey)
		AddSeriesXY(seriesName,strKey,strVal)
	Next
	Return Me
End Sub

'add xy values to a chart
Sub AddXY(X As String, y As String) As UOEChart
	'get the list of records
	Dim exdata As List = data.Get("a")
	Dim cudata As List
	cudata.Initialize
	cudata.Add(X)
	cudata.Add(y)
	exdata.Add(cudata)
	data.Put("a",exdata)
	Return Me
End Sub

'add xy with a color
Sub AddXYColor(X As String, y As String, color As String) As UOEChart
	'get the list of records
	Dim exdata As List = data.Get("a")
	Dim cudata As List
	cudata.Initialize
	cudata.Add(X)
	cudata.Add(y)
	exdata.Add(cudata)
	data.Put("a",exdata)
	colors.Add(color)
	Return Me
End Sub

'add xy map
Sub AddXYMap(values As Map) As UOEChart
	For Each strKey As String In values.Keys
		Dim strVal As String = values.Get(strKey)
		AddXY(strKey,strVal)
	Next
	Return Me
End Sub

'add a bubble
Sub AddBubble(X As String, y As String, size As String) As UOEChart
	'get the list of records
	Dim exdata As List = data.Get("a")
	Dim cudata As List
	cudata.Initialize
	cudata.Add(X)
	cudata.Add(y)
	cudata.Add(size)
	exdata.Add(cudata)
	data.Put("a",exdata)
	Return Me
End Sub

'refresh the chart
Sub Refresh
	If XNumeric Then xtype = "number"
	Dim plotdata As List
	plotdata.Initialize
	Dim tseries As Int = series.Size
	If tseries > 0 Then
		For Each seriesName As String In series.Keys
			'get the series color
			Dim seriesColor As String = series.Get(seriesName)
			'get the list of plot data
			Dim seriesData As List = data.Get(seriesName)
			'get the caption
			Dim seriesCap As String = seriestitle.Get(seriesName)
			'create each of the objects to plot
			Dim seriesObject As Map
			seriesObject.Initialize
			seriesObject.Put("name",$"${seriesCap}"$)
			seriesObject.Put("data", seriesData)
			If seriesColor <> "" Then
				Dim scolor As String = GetColorHex(seriesColor)
				seriesObject.Put("color",$"${scolor}"$)
			End If
			plotdata.Add(seriesObject)
		Next
	Else
		plotdata = data.Get("a")
	End If
	'lib options
	Dim lib As Map
	lib.Initialize
	Dim legendm As Map = CreateMap("position": LegendPosition)
	Dim chartm As Map = CreateMap("zoomType": zoomType)
	lib.Put("legend", legendm)
	lib.Put("chart", chartm)
	If BackgroundColor <> "" Then
		lib.Put("backgroundColor", BackgroundColor)
	End If
	Dim dataset As Map
	dataset.Initialize
		
	coptions.Put("library", lib)
	If Download Then coptions.Put("download", Download)
	If MinValue <> "" Then coptions.Put("min", MinValue)
	If MaxValue <> "" Then coptions.Put("max", MaxValue)
	If XTitle <> "" Then coptions.Put("xtitle", XTitle)
	If YTitle <> "" Then coptions.Put("ytitle", YTitle)
	If LineLabel <> "" Then coptions.Put("label", LineLabel)
	If Discrete = True Then coptions.Put("discrete",True)
	If Title <> "" Then coptions.Put("title", Title)
	If Prefix <> "" Then coptions.put("prefix",Prefix)
	If Suffix <> "" Then coptions.Put("suffix",Suffix)
	If Thousands <> "" Then coptions.Put("thousands",Thousands)
	If Decimal <> "" Then coptions.Put("decimal",Decimal)
	If xtype <> "" Then coptions.Put("xtype",xtype)
	If colors.Size > 0 Then
		coptions.Put("colors", colors)
	End If
	Dim bo As BANanoObject
	Select Case ChartType
		Case "AreaChart"
			bo.Initialize2("Chartkick.AreaChart",Array(mName, plotdata, coptions))
		Case "BarChart"
			If MaxValue <> "" Then coptions.Put("max",MaxValue)
			If Stacked Then
				If Percentage Then
					coptions.Put("stacked",Stacked)
				Else
					coptions.Put("stacked","percent")
				End If
			End If
			bo.Initialize2("Chartkick.BarChart",Array(mName, plotdata, coptions))
		Case "BubbleChart"
			bo.Initialize2("Chartkick.BubbleChart",Array(mName, plotdata, coptions))
		Case "ColumnChart"
			If MaxValue <> "" Then coptions.Put("max",MaxValue)
			If Stacked Then
				If Percentage Then
					coptions.Put("stacked",Stacked)
				Else
					coptions.Put("stacked","percent")
				End If
			End If
			bo.Initialize2("Chartkick.ColumnChart",Array(mName, plotdata, coptions))
		Case "LineChart"
			If BorderDash <> 0 Then
				Dim bd As List
				bd.Initialize 
				bd.Add(BorderDash)
				dataset.Put("borderDash",bd)
				coptions.Put("dataset", dataset)
			End If
			If Curve = False Then coptions.Put("curve",False)
			If Points = False Then coptions.Put("points",False)
			bo.Initialize2("Chartkick.LineChart",Array(mName, plotdata, coptions))
		Case "PieChart"
			coptions.Put("donut", Donut)
			If BorderWidth <> 0 Then
				dataset.Put("borderWidth",BorderWidth)
				coptions.Put("dataset", dataset)
			End If
			bo.Initialize2("Chartkick.PieChart",Array(mName, plotdata, coptions))
		Case "ScatterChart"
			If ShowLine Then
				dataset.put("showLine", ShowLine)
				coptions.Put("dataset", dataset)
			End If
			bo.Initialize2("Chartkick.ScatterChart",Array(mName, plotdata, coptions))
	End Select
End Sub

'get a hex color from provided colors
private Sub GetColorHex(sColor As String) As String
	sColor = sColor.tolowercase
	If colorMap.ContainsKey(sColor) Then
		Dim xColor As String = colorMap.Get(sColor)
		Return xColor
	End If
	Return ""
End Sub